/**
 * @file  FileDisplayColors.h
 * @brief Schnittstelle fuer die Klasse FileDisplayColors.
 */
//////////////////////////////////////////////////////////////////////
#ifndef FILEDISPLAYCOLORS_H
#define FILEDISPLAYCOLORS_H

#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

// Verwaltungsklasse fuer Datei
#include "fileintelhex.h"
// 16bit/32bit CRC
#include "../Common/crc.h"

// Strukturdefinitionen
#include "../Common/pzemaiv.h"

// Maximale Anzahl Datenbyte (512Byte)
#define MAX_MEM_DISPLAYCOLORS   0x200

// Maximale Anzahl DisplayColors
#define MAX_DISPLAYCOLORS   100

class FileDisplayColors : public FileIntelHex
{
public:
	FileDisplayColors();
	virtual ~FileDisplayColors();

public:
	unsigned int m_sizeData;

	// Verwaltungsstrukturen fuer TouchKey
	DISPLAYCOLORNODE *m_pDisplayColorsNode;
	DISPLAYCOLOR     *m_pDisplayColors[MAX_DISPLAYCOLORS];

	// Speicher fuer alle Daten
	unsigned char m_memDisplayColors[MAX_MEM_DISPLAYCOLORS];

public:
	void reset();
	int Load(const char *fileName);
	int Save(char *fileName, unsigned char append = 0);
	inline unsigned int GetSizeData() { return m_sizeData; };
  void Init(unsigned char count);
	int SetDisplayColor(int idx, DISPLAYCOLOR tk);
	DISPLAYCOLOR GetDisplayColor(int idx);
	int GetDisplayColorCount()
	{
		return m_pDisplayColorsNode->cnt;
	}

protected:
	int SaveDisplayColors(char *fileName, unsigned char append = 0);
};

#endif

